#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"

#ifndef INCcalcoutOOPTH
#define INCcalcoutOOPTH
typedef enum {
	calcoutOOPT_Every_Time,
	calcoutOOPT_On_Change,
	calcoutOOPT_When_Zero,
	calcoutOOPT_When_Non_zero,
	calcoutOOPT_Transition_To_Zero,
	calcoutOOPT_Transition_To_Non_zero
}calcoutOOPT;
#endif /*INCcalcoutOOPTH*/

#ifndef INCcalcoutINAVH
#define INCcalcoutINAVH
typedef enum {
	calcoutINAV_EXT_NC,
	calcoutINAV_EXT,
	calcoutINAV_LOC,
	calcoutINAV_CON
}calcoutINAV;
#endif /*INCcalcoutINAVH*/

#ifndef INCcalcoutINAPH
#define INCcalcoutINAPH
typedef enum {
	calcoutINAP_No,
	calcoutINAP_Yes
}calcoutINAP;
#endif /*INCcalcoutINAPH*/

#ifndef INCcalcoutDOPTH
#define INCcalcoutDOPTH
typedef enum {
	calcoutDOPT_Use_VAL,
	calcoutDOPT_Use_OVAL
}calcoutDOPT;
#endif /*INCcalcoutDOPTH*/
#ifndef INCcalcoutH
#define INCcalcoutH
typedef struct calcoutRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	float		vers;	/*Code Version*/
	void *         rpvt;	/*Record Private*/
	double		val;	/*Result*/
	double		pval;	/*Previous Value*/
	char		calc[36]; /*Calculation*/
	long		clcv;	/*CALC Valid*/
	DBLINK		inpa;	/*Input A*/
	DBLINK		inpb;	/*Input B*/
	DBLINK		inpc;	/*Input C*/
	DBLINK		inpd;	/*Input D*/
	DBLINK		inpe;	/*Input E*/
	DBLINK		inpf;	/*Input F*/
	DBLINK		inpg;	/*Input G*/
	DBLINK		inph;	/*Input H*/
	DBLINK		inpi;	/*Input I*/
	DBLINK		inpj;	/*Input J*/
	DBLINK		inpk;	/*Input K*/
	DBLINK		inpl;	/*Input L*/
	DBLINK		out;	/*Output Specification*/
	unsigned short	inav;	/*INPA PV Status*/
	unsigned short	inbv;	/*INPB PV Status*/
	unsigned short	incv;	/*INPC PV Status*/
	unsigned short	indv;	/*INPD PV Status*/
	unsigned short	inev;	/*INPE PV Status*/
	unsigned short	infv;	/*INPF PV Status*/
	unsigned short	ingv;	/*INPG PV Status*/
	unsigned short	inhv;	/*INPH PV Status*/
	unsigned short	iniv;	/*INPI PV Status*/
	unsigned short	injv;	/*INPJ PV Status*/
	unsigned short	inkv;	/*INPK PV Status*/
	unsigned short	inlv;	/*INPL PV Status*/
	unsigned short	outv;	/*OUT PV Status*/
	unsigned short	oopt;	/*Output Execute Opt*/
	float		odly;	/*Output Execute Delay*/
	unsigned short	dlya;	/*Output Delay Active*/
	unsigned short	dopt;	/*Output Data Opt*/
	char		ocal[36]; /*Output Calculation*/
	long		oclv;	/*OCAL Valid*/
	unsigned short	oevt;	/*Event To Issue*/
	unsigned short	ivoa;	/*INVALID output action*/
	double		ivov;	/*INVALID output value*/
	char		egu[16]; /*Units Name*/
	short		prec;	/*Display Precision*/
	float		hopr;	/*High Operating Rng*/
	float		lopr;	/*Low Operating Range*/
	float		hihi;	/*Hihi Alarm Limit*/
	float		lolo;	/*Lolo Alarm Limit*/
	float		high;	/*High Alarm Limit*/
	float		low;	/*Low Alarm Limit*/
	unsigned short	hhsv;	/*Hihi Severity*/
	unsigned short	llsv;	/*Lolo Severity*/
	unsigned short	hsv;	/*High Severity*/
	unsigned short	lsv;	/*Low Severity*/
	double		hyst;	/*Alarm Deadband*/
	double		adel;	/*Archive Deadband*/
	double		mdel;	/*Monitor Deadband*/
	double		a;	/*Value of Input A*/
	double		b;	/*Value of Input B*/
	double		c;	/*Value of Input C*/
	double		d;	/*Value of Input D*/
	double		e;	/*Value of Input E*/
	double		f;	/*Value of Input F*/
	double		g;	/*Value of Input G*/
	double		h;	/*Value of Input H*/
	double		i;	/*Value of Input I*/
	double		j;	/*Value of Input J*/
	double		k;	/*Value of Input K*/
	double		l;	/*Value of Input L*/
	double		oval;	/*Output Value*/
	double		la;	/*Prev Value of A*/
	double		lb;	/*Prev Value of B*/
	double		lc;	/*Prev Value of C*/
	double		ld;	/*Prev Value of D*/
	double		le;	/*Prev Value of E*/
	double		lf;	/*Prev Value of F*/
	double		lg;	/*Prev Value of G*/
	double		lh;	/*Prev Value of H*/
	double		li;	/*Prev Value of I*/
	double		lj;	/*Prev Value of J*/
	double		lk;	/*Prev Value of K*/
	double		ll;	/*Prev Value of L*/
	double		povl;	/*Prev Value of OVAL*/
	double		lalm;	/*Last Value Alarmed*/
	double		alst;	/*Last Value Archived*/
	double		mlst;	/*Last Val Monitored*/
	char	rpcl[184];	/*Reverse Polish Calc*/
	char	orpc[184];	/*Reverse Polish OCalc*/
} calcoutRecord;
#define calcoutRecordNAME	0
#define calcoutRecordDESC	1
#define calcoutRecordASG	2
#define calcoutRecordSCAN	3
#define calcoutRecordPINI	4
#define calcoutRecordPHAS	5
#define calcoutRecordEVNT	6
#define calcoutRecordTSE	7
#define calcoutRecordTSEL	8
#define calcoutRecordDTYP	9
#define calcoutRecordDISV	10
#define calcoutRecordDISA	11
#define calcoutRecordSDIS	12
#define calcoutRecordMLOK	13
#define calcoutRecordMLIS	14
#define calcoutRecordDISP	15
#define calcoutRecordPROC	16
#define calcoutRecordSTAT	17
#define calcoutRecordSEVR	18
#define calcoutRecordNSTA	19
#define calcoutRecordNSEV	20
#define calcoutRecordACKS	21
#define calcoutRecordACKT	22
#define calcoutRecordDISS	23
#define calcoutRecordLCNT	24
#define calcoutRecordPACT	25
#define calcoutRecordPUTF	26
#define calcoutRecordRPRO	27
#define calcoutRecordASP	28
#define calcoutRecordPPN	29
#define calcoutRecordPPNN	30
#define calcoutRecordSPVT	31
#define calcoutRecordRSET	32
#define calcoutRecordDSET	33
#define calcoutRecordDPVT	34
#define calcoutRecordRDES	35
#define calcoutRecordLSET	36
#define calcoutRecordPRIO	37
#define calcoutRecordTPRO	38
#define calcoutRecordBKPT	39
#define calcoutRecordUDF	40
#define calcoutRecordTIME	41
#define calcoutRecordFLNK	42
#define calcoutRecordVERS	43
#define calcoutRecordRPVT	44
#define calcoutRecordVAL	45
#define calcoutRecordPVAL	46
#define calcoutRecordCALC	47
#define calcoutRecordCLCV	48
#define calcoutRecordINPA	49
#define calcoutRecordINPB	50
#define calcoutRecordINPC	51
#define calcoutRecordINPD	52
#define calcoutRecordINPE	53
#define calcoutRecordINPF	54
#define calcoutRecordINPG	55
#define calcoutRecordINPH	56
#define calcoutRecordINPI	57
#define calcoutRecordINPJ	58
#define calcoutRecordINPK	59
#define calcoutRecordINPL	60
#define calcoutRecordOUT	61
#define calcoutRecordINAV	62
#define calcoutRecordINBV	63
#define calcoutRecordINCV	64
#define calcoutRecordINDV	65
#define calcoutRecordINEV	66
#define calcoutRecordINFV	67
#define calcoutRecordINGV	68
#define calcoutRecordINHV	69
#define calcoutRecordINIV	70
#define calcoutRecordINJV	71
#define calcoutRecordINKV	72
#define calcoutRecordINLV	73
#define calcoutRecordOUTV	74
#define calcoutRecordOOPT	75
#define calcoutRecordODLY	76
#define calcoutRecordDLYA	77
#define calcoutRecordDOPT	78
#define calcoutRecordOCAL	79
#define calcoutRecordOCLV	80
#define calcoutRecordOEVT	81
#define calcoutRecordIVOA	82
#define calcoutRecordIVOV	83
#define calcoutRecordEGU	84
#define calcoutRecordPREC	85
#define calcoutRecordHOPR	86
#define calcoutRecordLOPR	87
#define calcoutRecordHIHI	88
#define calcoutRecordLOLO	89
#define calcoutRecordHIGH	90
#define calcoutRecordLOW	91
#define calcoutRecordHHSV	92
#define calcoutRecordLLSV	93
#define calcoutRecordHSV	94
#define calcoutRecordLSV	95
#define calcoutRecordHYST	96
#define calcoutRecordADEL	97
#define calcoutRecordMDEL	98
#define calcoutRecordA	99
#define calcoutRecordB	100
#define calcoutRecordC	101
#define calcoutRecordD	102
#define calcoutRecordE	103
#define calcoutRecordF	104
#define calcoutRecordG	105
#define calcoutRecordH	106
#define calcoutRecordI	107
#define calcoutRecordJ	108
#define calcoutRecordK	109
#define calcoutRecordL	110
#define calcoutRecordOVAL	111
#define calcoutRecordLA	112
#define calcoutRecordLB	113
#define calcoutRecordLC	114
#define calcoutRecordLD	115
#define calcoutRecordLE	116
#define calcoutRecordLF	117
#define calcoutRecordLG	118
#define calcoutRecordLH	119
#define calcoutRecordLI	120
#define calcoutRecordLJ	121
#define calcoutRecordLK	122
#define calcoutRecordLL	123
#define calcoutRecordPOVL	124
#define calcoutRecordLALM	125
#define calcoutRecordALST	126
#define calcoutRecordMLST	127
#define calcoutRecordRPCL	128
#define calcoutRecordORPC	129
#endif /*INCcalcoutH*/
#ifdef GEN_SIZE_OFFSET
int calcoutRecordSizeOffset(dbRecordType *pdbRecordType)
{
    calcoutRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->vers);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->vers - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->rpvt);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->rpvt - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->pval);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->pval - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->calc);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->calc - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->clcv);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->clcv - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->inpa);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->inpa - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->inpb);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->inpb - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->inpc);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->inpc - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->inpd);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->inpd - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->inpe);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->inpe - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->inpf);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->inpf - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->inpg);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->inpg - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->inph);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->inph - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->inpi);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->inpi - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->inpj);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->inpj - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->inpk);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->inpk - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->inpl);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->inpl - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->out);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->out - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->inav);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->inav - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->inbv);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->inbv - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->incv);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->incv - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->indv);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->indv - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->inev);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->inev - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->infv);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->infv - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->ingv);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->ingv - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->inhv);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->inhv - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->iniv);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->iniv - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->injv);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->injv - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->inkv);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->inkv - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->inlv);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->inlv - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->outv);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->outv - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->oopt);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->oopt - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->odly);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->odly - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->dlya);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->dlya - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->dopt);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->dopt - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->ocal);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->ocal - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->oclv);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->oclv - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->oevt);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->oevt - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->ivoa);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->ivoa - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->ivov);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->ivov - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->egu);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->egu - (char *)prec);
  pdbRecordType->papFldDes[85]->size=sizeof(prec->prec);
  pdbRecordType->papFldDes[85]->offset=(short)((char *)&prec->prec - (char *)prec);
  pdbRecordType->papFldDes[86]->size=sizeof(prec->hopr);
  pdbRecordType->papFldDes[86]->offset=(short)((char *)&prec->hopr - (char *)prec);
  pdbRecordType->papFldDes[87]->size=sizeof(prec->lopr);
  pdbRecordType->papFldDes[87]->offset=(short)((char *)&prec->lopr - (char *)prec);
  pdbRecordType->papFldDes[88]->size=sizeof(prec->hihi);
  pdbRecordType->papFldDes[88]->offset=(short)((char *)&prec->hihi - (char *)prec);
  pdbRecordType->papFldDes[89]->size=sizeof(prec->lolo);
  pdbRecordType->papFldDes[89]->offset=(short)((char *)&prec->lolo - (char *)prec);
  pdbRecordType->papFldDes[90]->size=sizeof(prec->high);
  pdbRecordType->papFldDes[90]->offset=(short)((char *)&prec->high - (char *)prec);
  pdbRecordType->papFldDes[91]->size=sizeof(prec->low);
  pdbRecordType->papFldDes[91]->offset=(short)((char *)&prec->low - (char *)prec);
  pdbRecordType->papFldDes[92]->size=sizeof(prec->hhsv);
  pdbRecordType->papFldDes[92]->offset=(short)((char *)&prec->hhsv - (char *)prec);
  pdbRecordType->papFldDes[93]->size=sizeof(prec->llsv);
  pdbRecordType->papFldDes[93]->offset=(short)((char *)&prec->llsv - (char *)prec);
  pdbRecordType->papFldDes[94]->size=sizeof(prec->hsv);
  pdbRecordType->papFldDes[94]->offset=(short)((char *)&prec->hsv - (char *)prec);
  pdbRecordType->papFldDes[95]->size=sizeof(prec->lsv);
  pdbRecordType->papFldDes[95]->offset=(short)((char *)&prec->lsv - (char *)prec);
  pdbRecordType->papFldDes[96]->size=sizeof(prec->hyst);
  pdbRecordType->papFldDes[96]->offset=(short)((char *)&prec->hyst - (char *)prec);
  pdbRecordType->papFldDes[97]->size=sizeof(prec->adel);
  pdbRecordType->papFldDes[97]->offset=(short)((char *)&prec->adel - (char *)prec);
  pdbRecordType->papFldDes[98]->size=sizeof(prec->mdel);
  pdbRecordType->papFldDes[98]->offset=(short)((char *)&prec->mdel - (char *)prec);
  pdbRecordType->papFldDes[99]->size=sizeof(prec->a);
  pdbRecordType->papFldDes[99]->offset=(short)((char *)&prec->a - (char *)prec);
  pdbRecordType->papFldDes[100]->size=sizeof(prec->b);
  pdbRecordType->papFldDes[100]->offset=(short)((char *)&prec->b - (char *)prec);
  pdbRecordType->papFldDes[101]->size=sizeof(prec->c);
  pdbRecordType->papFldDes[101]->offset=(short)((char *)&prec->c - (char *)prec);
  pdbRecordType->papFldDes[102]->size=sizeof(prec->d);
  pdbRecordType->papFldDes[102]->offset=(short)((char *)&prec->d - (char *)prec);
  pdbRecordType->papFldDes[103]->size=sizeof(prec->e);
  pdbRecordType->papFldDes[103]->offset=(short)((char *)&prec->e - (char *)prec);
  pdbRecordType->papFldDes[104]->size=sizeof(prec->f);
  pdbRecordType->papFldDes[104]->offset=(short)((char *)&prec->f - (char *)prec);
  pdbRecordType->papFldDes[105]->size=sizeof(prec->g);
  pdbRecordType->papFldDes[105]->offset=(short)((char *)&prec->g - (char *)prec);
  pdbRecordType->papFldDes[106]->size=sizeof(prec->h);
  pdbRecordType->papFldDes[106]->offset=(short)((char *)&prec->h - (char *)prec);
  pdbRecordType->papFldDes[107]->size=sizeof(prec->i);
  pdbRecordType->papFldDes[107]->offset=(short)((char *)&prec->i - (char *)prec);
  pdbRecordType->papFldDes[108]->size=sizeof(prec->j);
  pdbRecordType->papFldDes[108]->offset=(short)((char *)&prec->j - (char *)prec);
  pdbRecordType->papFldDes[109]->size=sizeof(prec->k);
  pdbRecordType->papFldDes[109]->offset=(short)((char *)&prec->k - (char *)prec);
  pdbRecordType->papFldDes[110]->size=sizeof(prec->l);
  pdbRecordType->papFldDes[110]->offset=(short)((char *)&prec->l - (char *)prec);
  pdbRecordType->papFldDes[111]->size=sizeof(prec->oval);
  pdbRecordType->papFldDes[111]->offset=(short)((char *)&prec->oval - (char *)prec);
  pdbRecordType->papFldDes[112]->size=sizeof(prec->la);
  pdbRecordType->papFldDes[112]->offset=(short)((char *)&prec->la - (char *)prec);
  pdbRecordType->papFldDes[113]->size=sizeof(prec->lb);
  pdbRecordType->papFldDes[113]->offset=(short)((char *)&prec->lb - (char *)prec);
  pdbRecordType->papFldDes[114]->size=sizeof(prec->lc);
  pdbRecordType->papFldDes[114]->offset=(short)((char *)&prec->lc - (char *)prec);
  pdbRecordType->papFldDes[115]->size=sizeof(prec->ld);
  pdbRecordType->papFldDes[115]->offset=(short)((char *)&prec->ld - (char *)prec);
  pdbRecordType->papFldDes[116]->size=sizeof(prec->le);
  pdbRecordType->papFldDes[116]->offset=(short)((char *)&prec->le - (char *)prec);
  pdbRecordType->papFldDes[117]->size=sizeof(prec->lf);
  pdbRecordType->papFldDes[117]->offset=(short)((char *)&prec->lf - (char *)prec);
  pdbRecordType->papFldDes[118]->size=sizeof(prec->lg);
  pdbRecordType->papFldDes[118]->offset=(short)((char *)&prec->lg - (char *)prec);
  pdbRecordType->papFldDes[119]->size=sizeof(prec->lh);
  pdbRecordType->papFldDes[119]->offset=(short)((char *)&prec->lh - (char *)prec);
  pdbRecordType->papFldDes[120]->size=sizeof(prec->li);
  pdbRecordType->papFldDes[120]->offset=(short)((char *)&prec->li - (char *)prec);
  pdbRecordType->papFldDes[121]->size=sizeof(prec->lj);
  pdbRecordType->papFldDes[121]->offset=(short)((char *)&prec->lj - (char *)prec);
  pdbRecordType->papFldDes[122]->size=sizeof(prec->lk);
  pdbRecordType->papFldDes[122]->offset=(short)((char *)&prec->lk - (char *)prec);
  pdbRecordType->papFldDes[123]->size=sizeof(prec->ll);
  pdbRecordType->papFldDes[123]->offset=(short)((char *)&prec->ll - (char *)prec);
  pdbRecordType->papFldDes[124]->size=sizeof(prec->povl);
  pdbRecordType->papFldDes[124]->offset=(short)((char *)&prec->povl - (char *)prec);
  pdbRecordType->papFldDes[125]->size=sizeof(prec->lalm);
  pdbRecordType->papFldDes[125]->offset=(short)((char *)&prec->lalm - (char *)prec);
  pdbRecordType->papFldDes[126]->size=sizeof(prec->alst);
  pdbRecordType->papFldDes[126]->offset=(short)((char *)&prec->alst - (char *)prec);
  pdbRecordType->papFldDes[127]->size=sizeof(prec->mlst);
  pdbRecordType->papFldDes[127]->offset=(short)((char *)&prec->mlst - (char *)prec);
  pdbRecordType->papFldDes[128]->size=sizeof(prec->rpcl);
  pdbRecordType->papFldDes[128]->offset=(short)((char *)&prec->rpcl - (char *)prec);
  pdbRecordType->papFldDes[129]->size=sizeof(prec->orpc);
  pdbRecordType->papFldDes[129]->offset=(short)((char *)&prec->orpc - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
