#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"
#ifndef INCdfanoutH
#define INCdfanoutH
typedef struct dfanoutRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	long		val;	/*Desired Output*/
	DBLINK		outa;	/*Output Spec A*/
	DBLINK		outb;	/*Output Spec B*/
	DBLINK		outc;	/*Output Spec C*/
	DBLINK		outd;	/*Output Spec D*/
	DBLINK		oute;	/*Output Spec E*/
	DBLINK		outf;	/*Output Spec F*/
	DBLINK		outg;	/*Output Spec G*/
	DBLINK		outh;	/*Output Spec H*/
	DBLINK		dol;	/*Desired Output Loc*/
	unsigned short	omsl;	/*Output Mode Select*/
	char		egu[16]; /*Units name*/
	long		hopr;	/*High Operating Range*/
	long		lopr;	/*Low Operating Range*/
	long		hihi;	/*Hihi Alarm Limit*/
	long		lolo;	/*Lolo Alarm Limit*/
	long		high;	/*High Alarm Limit*/
	long		low;	/*Low Alarm Limit*/
	unsigned short	hhsv;	/*Hihi Severity*/
	unsigned short	llsv;	/*Lolo Severity*/
	unsigned short	hsv;	/*High Severity*/
	unsigned short	lsv;	/*Low Severity*/
	long		hyst;	/*Alarm Deadband*/
	long		adel;	/*Archive Deadband*/
	long		mdel;	/*Monitor Deadband*/
	long		lalm;	/*Last Value Alarmed*/
	long		alst;	/*Last Value Archived*/
	long		mlst;	/*Last Val Monitored*/
	unsigned short	ivoa;	/*INVALID output action*/
	long		ivov;	/*INVALID output value*/
} dfanoutRecord;
#define dfanoutRecordNAME	0
#define dfanoutRecordDESC	1
#define dfanoutRecordASG	2
#define dfanoutRecordSCAN	3
#define dfanoutRecordPINI	4
#define dfanoutRecordPHAS	5
#define dfanoutRecordEVNT	6
#define dfanoutRecordTSE	7
#define dfanoutRecordTSEL	8
#define dfanoutRecordDTYP	9
#define dfanoutRecordDISV	10
#define dfanoutRecordDISA	11
#define dfanoutRecordSDIS	12
#define dfanoutRecordMLOK	13
#define dfanoutRecordMLIS	14
#define dfanoutRecordDISP	15
#define dfanoutRecordPROC	16
#define dfanoutRecordSTAT	17
#define dfanoutRecordSEVR	18
#define dfanoutRecordNSTA	19
#define dfanoutRecordNSEV	20
#define dfanoutRecordACKS	21
#define dfanoutRecordACKT	22
#define dfanoutRecordDISS	23
#define dfanoutRecordLCNT	24
#define dfanoutRecordPACT	25
#define dfanoutRecordPUTF	26
#define dfanoutRecordRPRO	27
#define dfanoutRecordASP	28
#define dfanoutRecordPPN	29
#define dfanoutRecordPPNN	30
#define dfanoutRecordSPVT	31
#define dfanoutRecordRSET	32
#define dfanoutRecordDSET	33
#define dfanoutRecordDPVT	34
#define dfanoutRecordRDES	35
#define dfanoutRecordLSET	36
#define dfanoutRecordPRIO	37
#define dfanoutRecordTPRO	38
#define dfanoutRecordBKPT	39
#define dfanoutRecordUDF	40
#define dfanoutRecordTIME	41
#define dfanoutRecordFLNK	42
#define dfanoutRecordVAL	43
#define dfanoutRecordOUTA	44
#define dfanoutRecordOUTB	45
#define dfanoutRecordOUTC	46
#define dfanoutRecordOUTD	47
#define dfanoutRecordOUTE	48
#define dfanoutRecordOUTF	49
#define dfanoutRecordOUTG	50
#define dfanoutRecordOUTH	51
#define dfanoutRecordDOL	52
#define dfanoutRecordOMSL	53
#define dfanoutRecordEGU	54
#define dfanoutRecordHOPR	55
#define dfanoutRecordLOPR	56
#define dfanoutRecordHIHI	57
#define dfanoutRecordLOLO	58
#define dfanoutRecordHIGH	59
#define dfanoutRecordLOW	60
#define dfanoutRecordHHSV	61
#define dfanoutRecordLLSV	62
#define dfanoutRecordHSV	63
#define dfanoutRecordLSV	64
#define dfanoutRecordHYST	65
#define dfanoutRecordADEL	66
#define dfanoutRecordMDEL	67
#define dfanoutRecordLALM	68
#define dfanoutRecordALST	69
#define dfanoutRecordMLST	70
#define dfanoutRecordIVOA	71
#define dfanoutRecordIVOV	72
#endif /*INCdfanoutH*/
#ifdef GEN_SIZE_OFFSET
int dfanoutRecordSizeOffset(dbRecordType *pdbRecordType)
{
    dfanoutRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->outa);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->outa - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->outb);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->outb - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->outc);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->outc - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->outd);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->outd - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->oute);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->oute - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->outf);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->outf - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->outg);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->outg - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->outh);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->outh - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->dol);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->dol - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->omsl);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->omsl - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->egu);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->egu - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->hopr);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->hopr - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->lopr);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->lopr - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->hihi);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->hihi - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->lolo);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->lolo - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->high);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->high - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->low);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->low - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->hhsv);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->hhsv - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->llsv);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->llsv - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->hsv);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->hsv - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->lsv);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->lsv - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->hyst);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->hyst - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->adel);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->adel - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->mdel);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->mdel - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->lalm);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->lalm - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->alst);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->alst - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->mlst);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->mlst - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->ivoa);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->ivoa - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->ivov);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->ivov - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
