#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"

#ifndef INCegMOD1H
#define INCegMOD1H
typedef enum {
	egMOD1_Off,
	egMOD1_Normal,
	egMOD1_Normal_Recycle,
	egMOD1_Single,
	egMOD1_Alternate
}egMOD1;
#endif /*INCegMOD1H*/
#ifndef INCegH
#define INCegH
typedef struct egRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	DBLINK		out;	/*Output Specification*/
	unsigned short	mod1;	/*RAM 1 Operating Mode*/
	double		r1sp;	/*RAM 1 Clock (Hz)*/
	unsigned short	mod2;	/*RAM 2 Operating Mode*/
	double		r2sp;	/*RAM 2 Clock (Hz)*/
	unsigned short	lmd1;	/*Last Operating Mode1*/
	unsigned short	lmd2;	/*Last Operating Mode2*/
	unsigned short	fifo;	/*Input FIFO Enable*/
	unsigned short	lffo;	/*Last FIFO Enable*/
	char		clr1;	/*Clear Sequence 1*/
	char		clr2;	/*Clear Sequence 2*/
	char		trg1;	/*Trigger Sequence 1*/
	char		trg2;	/*Trigger Sequence 2*/
	unsigned short	enab;	/*Master Enable*/
	long		lena;	/*Last Master Enable*/
	long		taxi;	/*Taxi Violation*/
	long		ltax;	/*Last Taxi Violation*/
	long		vme;	/*Generate VME Event*/
	unsigned short	ete0;	/*Trigger 0 Enable*/
	long		et0;	/*Trigger 0 Event*/
	long		let0;	/*Last Trigger 0 Event*/
	unsigned short	ete1;	/*Trigger 1 Enable*/
	long		et1;	/*Trigger 1 Event*/
	long		let1;	/*Last Trigger 1 Event*/
	unsigned short	ete2;	/*Trigger 2 Enable*/
	long		et2;	/*Trigger 2 Event*/
	long		let2;	/*Last Trigger 2 Event*/
	unsigned short	ete3;	/*Trigger 3 Enable*/
	long		et3;	/*Trigger 3 Event*/
	long		let3;	/*Last Trigger 3 Event*/
	unsigned short	ete4;	/*Trigger 4 Enable*/
	long		et4;	/*Trigger 4 Event*/
	long		let4;	/*Last Trigger 4 Event*/
	unsigned short	ete5;	/*Trigger 5 Enable*/
	long		et5;	/*Trigger 5 Event*/
	long		let5;	/*Last Trigger 5 Event*/
	unsigned short	ete6;	/*Trigger 6 Enable*/
	long		et6;	/*Trigger 6 Event*/
	long		let6;	/*Last Trigger 6 Event*/
	unsigned short	ete7;	/*Trigger 7 Enable*/
	long		et7;	/*Trigger 7 Event*/
	long		let7;	/*Last Trigger 7 Event*/
	char		val;	/*Worthless Value*/
} egRecord;
#define egRecordNAME	0
#define egRecordDESC	1
#define egRecordASG	2
#define egRecordSCAN	3
#define egRecordPINI	4
#define egRecordPHAS	5
#define egRecordEVNT	6
#define egRecordTSE	7
#define egRecordTSEL	8
#define egRecordDTYP	9
#define egRecordDISV	10
#define egRecordDISA	11
#define egRecordSDIS	12
#define egRecordMLOK	13
#define egRecordMLIS	14
#define egRecordDISP	15
#define egRecordPROC	16
#define egRecordSTAT	17
#define egRecordSEVR	18
#define egRecordNSTA	19
#define egRecordNSEV	20
#define egRecordACKS	21
#define egRecordACKT	22
#define egRecordDISS	23
#define egRecordLCNT	24
#define egRecordPACT	25
#define egRecordPUTF	26
#define egRecordRPRO	27
#define egRecordASP	28
#define egRecordPPN	29
#define egRecordPPNN	30
#define egRecordSPVT	31
#define egRecordRSET	32
#define egRecordDSET	33
#define egRecordDPVT	34
#define egRecordRDES	35
#define egRecordLSET	36
#define egRecordPRIO	37
#define egRecordTPRO	38
#define egRecordBKPT	39
#define egRecordUDF	40
#define egRecordTIME	41
#define egRecordFLNK	42
#define egRecordOUT	43
#define egRecordMOD1	44
#define egRecordR1SP	45
#define egRecordMOD2	46
#define egRecordR2SP	47
#define egRecordLMD1	48
#define egRecordLMD2	49
#define egRecordFIFO	50
#define egRecordLFFO	51
#define egRecordCLR1	52
#define egRecordCLR2	53
#define egRecordTRG1	54
#define egRecordTRG2	55
#define egRecordENAB	56
#define egRecordLENA	57
#define egRecordTAXI	58
#define egRecordLTAX	59
#define egRecordVME	60
#define egRecordETE0	61
#define egRecordET0	62
#define egRecordLET0	63
#define egRecordETE1	64
#define egRecordET1	65
#define egRecordLET1	66
#define egRecordETE2	67
#define egRecordET2	68
#define egRecordLET2	69
#define egRecordETE3	70
#define egRecordET3	71
#define egRecordLET3	72
#define egRecordETE4	73
#define egRecordET4	74
#define egRecordLET4	75
#define egRecordETE5	76
#define egRecordET5	77
#define egRecordLET5	78
#define egRecordETE6	79
#define egRecordET6	80
#define egRecordLET6	81
#define egRecordETE7	82
#define egRecordET7	83
#define egRecordLET7	84
#define egRecordVAL	85
#endif /*INCegH*/
#ifdef GEN_SIZE_OFFSET
int egRecordSizeOffset(dbRecordType *pdbRecordType)
{
    egRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->out);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->out - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->mod1);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->mod1 - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->r1sp);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->r1sp - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->mod2);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->mod2 - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->r2sp);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->r2sp - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->lmd1);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->lmd1 - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->lmd2);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->lmd2 - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->fifo);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->fifo - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->lffo);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->lffo - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->clr1);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->clr1 - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->clr2);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->clr2 - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->trg1);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->trg1 - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->trg2);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->trg2 - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->enab);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->enab - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->lena);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->lena - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->taxi);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->taxi - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->ltax);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->ltax - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->vme);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->vme - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->ete0);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->ete0 - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->et0);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->et0 - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->let0);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->let0 - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->ete1);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->ete1 - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->et1);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->et1 - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->let1);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->let1 - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->ete2);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->ete2 - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->et2);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->et2 - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->let2);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->let2 - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->ete3);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->ete3 - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->et3);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->et3 - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->let3);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->let3 - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->ete4);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->ete4 - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->et4);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->et4 - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->let4);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->let4 - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->ete5);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->ete5 - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->et5);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->et5 - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->let5);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->let5 - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->ete6);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->ete6 - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->et6);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->et6 - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->let6);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->let6 - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->ete7);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->ete7 - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->et7);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->et7 - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->let7);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->let7 - (char *)prec);
  pdbRecordType->papFldDes[85]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[85]->offset=(short)((char *)&prec->val - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
