#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"

#ifndef INCerTRG0H
#define INCerTRG0H
typedef enum {
	erTRG0_Disabled,
	erTRG0_Enabled
}erTRG0;
#endif /*INCerTRG0H*/
#ifndef INCerH
#define INCerH
typedef struct erRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	char		val;	/*Worthless Value*/
	DBLINK		out;	/*Output Specification*/
	unsigned short	enab;	/*Master Enable*/
	long		taxi;	/*Taxi Violation*/
	long		ltax;	/*Last Taxi Violation*/
	unsigned short	trg0;	/*Trigger 0 Enable*/
	unsigned short	trg1;	/*Trigger 1 Enable*/
	unsigned short	trg2;	/*Trigger 2 Enable*/
	unsigned short	trg3;	/*Trigger 3 Enable*/
	unsigned short	trg4;	/*Trigger 4 Enable*/
	unsigned short	trg5;	/*Trigger 5 Enable*/
	unsigned short	trg6;	/*Trigger 6 Enable*/
	unsigned short	otp0;	/*OTP 0 Enable*/
	unsigned short	otp1;	/*OTP 1 Enable*/
	unsigned short	otp2;	/*OTP 2 Enable*/
	unsigned short	otp3;	/*OTP 3 Enable*/
	unsigned short	otp4;	/*OTP 4 Enable*/
	unsigned short	otp5;	/*OTP 5 Enable*/
	unsigned short	otp6;	/*OTP 6 Enable*/
	unsigned short	otp7;	/*OTP 7 Enable*/
	unsigned short	otp8;	/*OTP 8 Enable*/
	unsigned short	otp9;	/*OTP 9 Enable*/
	unsigned short	otpa;	/*OTP 10 Enable*/
	unsigned short	otpb;	/*OTP 11 Enable*/
	unsigned short	otpc;	/*OTP 12 Enable*/
	unsigned short	otpd;	/*OTP 13 Enable*/
	unsigned short	otl0;	/*OTL 0 Enable*/
	unsigned short	otl1;	/*OTL 1 Enable*/
	unsigned short	otl2;	/*OTL 2 Enable*/
	unsigned short	otl3;	/*OTL 3 Enable*/
	unsigned short	otl4;	/*OTL 4 Enable*/
	unsigned short	otl5;	/*OTL 5 Enable*/
	unsigned short	otl6;	/*OTL 6 Enable*/
	long		dgcm;	/*DG Change Mask*/
	unsigned short	dg0e;	/*DG 0 Enable*/
	unsigned short	dg0d;	/*DG 0 Delay*/
	unsigned short	dg0w;	/*DG 0 Width*/
	unsigned short	dg1e;	/*DG 1 Enable*/
	unsigned short	dg1d;	/*DG 1 Delay*/
	unsigned short	dg1w;	/*DG 1 Width*/
	unsigned short	dg2e;	/*DG 2 Enable*/
	unsigned short	dg2d;	/*DG 2 Delay*/
	unsigned short	dg2w;	/*DG 2 Width*/
	unsigned short	dg3e;	/*DG 3 Enable*/
	unsigned short	dg3d;	/*DG 3 Delay*/
	unsigned short	dg3w;	/*DG 3 Width*/
} erRecord;
#define erRecordNAME	0
#define erRecordDESC	1
#define erRecordASG	2
#define erRecordSCAN	3
#define erRecordPINI	4
#define erRecordPHAS	5
#define erRecordEVNT	6
#define erRecordTSE	7
#define erRecordTSEL	8
#define erRecordDTYP	9
#define erRecordDISV	10
#define erRecordDISA	11
#define erRecordSDIS	12
#define erRecordMLOK	13
#define erRecordMLIS	14
#define erRecordDISP	15
#define erRecordPROC	16
#define erRecordSTAT	17
#define erRecordSEVR	18
#define erRecordNSTA	19
#define erRecordNSEV	20
#define erRecordACKS	21
#define erRecordACKT	22
#define erRecordDISS	23
#define erRecordLCNT	24
#define erRecordPACT	25
#define erRecordPUTF	26
#define erRecordRPRO	27
#define erRecordASP	28
#define erRecordPPN	29
#define erRecordPPNN	30
#define erRecordSPVT	31
#define erRecordRSET	32
#define erRecordDSET	33
#define erRecordDPVT	34
#define erRecordRDES	35
#define erRecordLSET	36
#define erRecordPRIO	37
#define erRecordTPRO	38
#define erRecordBKPT	39
#define erRecordUDF	40
#define erRecordTIME	41
#define erRecordFLNK	42
#define erRecordVAL	43
#define erRecordOUT	44
#define erRecordENAB	45
#define erRecordTAXI	46
#define erRecordLTAX	47
#define erRecordTRG0	48
#define erRecordTRG1	49
#define erRecordTRG2	50
#define erRecordTRG3	51
#define erRecordTRG4	52
#define erRecordTRG5	53
#define erRecordTRG6	54
#define erRecordOTP0	55
#define erRecordOTP1	56
#define erRecordOTP2	57
#define erRecordOTP3	58
#define erRecordOTP4	59
#define erRecordOTP5	60
#define erRecordOTP6	61
#define erRecordOTP7	62
#define erRecordOTP8	63
#define erRecordOTP9	64
#define erRecordOTPA	65
#define erRecordOTPB	66
#define erRecordOTPC	67
#define erRecordOTPD	68
#define erRecordOTL0	69
#define erRecordOTL1	70
#define erRecordOTL2	71
#define erRecordOTL3	72
#define erRecordOTL4	73
#define erRecordOTL5	74
#define erRecordOTL6	75
#define erRecordDGCM	76
#define erRecordDG0E	77
#define erRecordDG0D	78
#define erRecordDG0W	79
#define erRecordDG1E	80
#define erRecordDG1D	81
#define erRecordDG1W	82
#define erRecordDG2E	83
#define erRecordDG2D	84
#define erRecordDG2W	85
#define erRecordDG3E	86
#define erRecordDG3D	87
#define erRecordDG3W	88
#endif /*INCerH*/
#ifdef GEN_SIZE_OFFSET
int erRecordSizeOffset(dbRecordType *pdbRecordType)
{
    erRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->out);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->out - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->enab);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->enab - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->taxi);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->taxi - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->ltax);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->ltax - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->trg0);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->trg0 - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->trg1);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->trg1 - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->trg2);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->trg2 - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->trg3);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->trg3 - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->trg4);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->trg4 - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->trg5);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->trg5 - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->trg6);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->trg6 - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->otp0);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->otp0 - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->otp1);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->otp1 - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->otp2);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->otp2 - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->otp3);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->otp3 - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->otp4);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->otp4 - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->otp5);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->otp5 - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->otp6);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->otp6 - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->otp7);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->otp7 - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->otp8);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->otp8 - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->otp9);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->otp9 - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->otpa);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->otpa - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->otpb);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->otpb - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->otpc);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->otpc - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->otpd);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->otpd - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->otl0);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->otl0 - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->otl1);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->otl1 - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->otl2);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->otl2 - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->otl3);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->otl3 - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->otl4);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->otl4 - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->otl5);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->otl5 - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->otl6);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->otl6 - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->dgcm);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->dgcm - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->dg0e);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->dg0e - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->dg0d);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->dg0d - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->dg0w);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->dg0w - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->dg1e);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->dg1e - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->dg1d);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->dg1d - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->dg1w);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->dg1w - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->dg2e);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->dg2e - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->dg2d);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->dg2d - (char *)prec);
  pdbRecordType->papFldDes[85]->size=sizeof(prec->dg2w);
  pdbRecordType->papFldDes[85]->offset=(short)((char *)&prec->dg2w - (char *)prec);
  pdbRecordType->papFldDes[86]->size=sizeof(prec->dg3e);
  pdbRecordType->papFldDes[86]->offset=(short)((char *)&prec->dg3e - (char *)prec);
  pdbRecordType->papFldDes[87]->size=sizeof(prec->dg3d);
  pdbRecordType->papFldDes[87]->offset=(short)((char *)&prec->dg3d - (char *)prec);
  pdbRecordType->papFldDes[88]->size=sizeof(prec->dg3w);
  pdbRecordType->papFldDes[88]->offset=(short)((char *)&prec->dg3w - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
