#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"
#ifndef INCgsubH
#define INCgsubH
typedef struct gsubRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	float		val;	/*Result*/
	char		inam[16]; /*Init Routine Name*/
	char		snam[16]; /*Subroutine Name*/
	void *		sadr;	/*Subroutine Address*/
	short		styp;	/*Subr symbol type*/
	DBLINK		inpa;	/*Input A*/
	DBLINK		inpb;	/*Input B*/
	DBLINK		inpc;	/*Input C*/
	DBLINK		inpd;	/*Input D*/
	DBLINK		inpe;	/*Input E*/
	DBLINK		inpf;	/*Input F*/
	char		egu[16]; /*Units Name*/
	float		hopr;	/*High Operating Rng*/
	float		lopr;	/*Low Operating Range*/
	float		hihi;	/*Hihi Alarm Limit*/
	float		lolo;	/*Lolo Alarm Limit*/
	float		high;	/*High Alarm Limit*/
	float		low;	/*Low Alarm Limit*/
	short		prec;	/*Display Precision*/
	unsigned short	brsv;	/*Bad Return Severity*/
	unsigned short	hhsv;	/*Hihi Severity*/
	unsigned short	llsv;	/*Lolo Severity*/
	unsigned short	hsv;	/*High Severity*/
	unsigned short	lsv;	/*Low Severity*/
	double		hyst;	/*Alarm Deadband*/
	double		adel;	/*Archive Deadband*/
	double		mdel;	/*Monitor Deadband*/
	float		a;	/*Value of Input A*/
	float		b;	/*Value of Input B*/
	float		c;	/*Value of Input C*/
	float		d;	/*Value of Input D*/
	float		e;	/*Value of Input E*/
	float		f;	/*Value of Input F*/
	float		la;	/*Prev Value of A*/
	float		lb;	/*Prev Value of B*/
	float		lc;	/*Prev Value of C*/
	float		ld;	/*Prev Value of D*/
	float		le;	/*Prev Value of E*/
	float		lf;	/*Prev Value of F*/
	float		lalm;	/*Last Value Alarmed*/
	float		alst;	/*Last Value Archived*/
	float		mlst;	/*Last Value Monitored*/
} gsubRecord;
#define gsubRecordNAME	0
#define gsubRecordDESC	1
#define gsubRecordASG	2
#define gsubRecordSCAN	3
#define gsubRecordPINI	4
#define gsubRecordPHAS	5
#define gsubRecordEVNT	6
#define gsubRecordTSE	7
#define gsubRecordTSEL	8
#define gsubRecordDTYP	9
#define gsubRecordDISV	10
#define gsubRecordDISA	11
#define gsubRecordSDIS	12
#define gsubRecordMLOK	13
#define gsubRecordMLIS	14
#define gsubRecordDISP	15
#define gsubRecordPROC	16
#define gsubRecordSTAT	17
#define gsubRecordSEVR	18
#define gsubRecordNSTA	19
#define gsubRecordNSEV	20
#define gsubRecordACKS	21
#define gsubRecordACKT	22
#define gsubRecordDISS	23
#define gsubRecordLCNT	24
#define gsubRecordPACT	25
#define gsubRecordPUTF	26
#define gsubRecordRPRO	27
#define gsubRecordASP	28
#define gsubRecordPPN	29
#define gsubRecordPPNN	30
#define gsubRecordSPVT	31
#define gsubRecordRSET	32
#define gsubRecordDSET	33
#define gsubRecordDPVT	34
#define gsubRecordRDES	35
#define gsubRecordLSET	36
#define gsubRecordPRIO	37
#define gsubRecordTPRO	38
#define gsubRecordBKPT	39
#define gsubRecordUDF	40
#define gsubRecordTIME	41
#define gsubRecordFLNK	42
#define gsubRecordVAL	43
#define gsubRecordINAM	44
#define gsubRecordSNAM	45
#define gsubRecordSADR	46
#define gsubRecordSTYP	47
#define gsubRecordINPA	48
#define gsubRecordINPB	49
#define gsubRecordINPC	50
#define gsubRecordINPD	51
#define gsubRecordINPE	52
#define gsubRecordINPF	53
#define gsubRecordEGU	54
#define gsubRecordHOPR	55
#define gsubRecordLOPR	56
#define gsubRecordHIHI	57
#define gsubRecordLOLO	58
#define gsubRecordHIGH	59
#define gsubRecordLOW	60
#define gsubRecordPREC	61
#define gsubRecordBRSV	62
#define gsubRecordHHSV	63
#define gsubRecordLLSV	64
#define gsubRecordHSV	65
#define gsubRecordLSV	66
#define gsubRecordHYST	67
#define gsubRecordADEL	68
#define gsubRecordMDEL	69
#define gsubRecordA	70
#define gsubRecordB	71
#define gsubRecordC	72
#define gsubRecordD	73
#define gsubRecordE	74
#define gsubRecordF	75
#define gsubRecordLA	76
#define gsubRecordLB	77
#define gsubRecordLC	78
#define gsubRecordLD	79
#define gsubRecordLE	80
#define gsubRecordLF	81
#define gsubRecordLALM	82
#define gsubRecordALST	83
#define gsubRecordMLST	84
#endif /*INCgsubH*/
#ifdef GEN_SIZE_OFFSET
int gsubRecordSizeOffset(dbRecordType *pdbRecordType)
{
    gsubRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->inam);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->inam - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->snam);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->snam - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->sadr);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->sadr - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->styp);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->styp - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->inpa);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->inpa - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->inpb);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->inpb - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->inpc);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->inpc - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->inpd);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->inpd - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->inpe);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->inpe - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->inpf);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->inpf - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->egu);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->egu - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->hopr);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->hopr - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->lopr);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->lopr - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->hihi);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->hihi - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->lolo);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->lolo - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->high);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->high - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->low);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->low - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->prec);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->prec - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->brsv);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->brsv - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->hhsv);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->hhsv - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->llsv);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->llsv - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->hsv);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->hsv - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->lsv);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->lsv - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->hyst);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->hyst - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->adel);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->adel - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->mdel);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->mdel - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->a);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->a - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->b);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->b - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->c);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->c - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->d);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->d - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->e);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->e - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->f);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->f - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->la);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->la - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->lb);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->lb - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->lc);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->lc - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->ld);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->ld - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->le);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->le - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->lf);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->lf - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->lalm);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->lalm - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->alst);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->alst - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->mlst);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->mlst - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
