#include <vxWorks.h>
#include <semLib.h>
#include "ellLib.h"
#include "fast_lock.h"
#include "link.h"
#include "tsDefs.h"
#ifndef INCpalH
#define INCpalH
typedef struct palRecord {
	char		name[29]; /*Record Name*/
	char		desc[29]; /*Descriptor*/
	char		asg[29]; /*Access Security Group*/
	unsigned short	scan;	/*Scan Mechanism*/
	unsigned short	pini;	/*Process at iocInit*/
	short		phas;	/*Scan Phase*/
	short		evnt;	/*Event Number*/
	short		tse;	/*Time Stamp Event*/
	DBLINK		tsel;	/*Time Stamp Link*/
	unsigned short	dtyp;	/*Device Type*/
	short		disv;	/*Disable Value*/
	short		disa;	/*Disable*/
	DBLINK		sdis;	/*Scanning Disable*/
	FAST_LOCK	mlok;	/*Monitor fastlock*/
	ELLLIST		mlis;	/*Monitor List*/
	unsigned char	disp;	/*Disable putField*/
	unsigned char	proc;	/*Force Processing*/
	unsigned short	stat;	/*Alarm Status*/
	unsigned short	sevr;	/*Alarm Severity*/
	unsigned short	nsta;	/*New Alarm Status*/
	unsigned short	nsev;	/*New Alarm Severity*/
	unsigned short	acks;	/*Alarm Ack Severity*/
	unsigned short	ackt;	/*Alarm Ack Transient*/
	unsigned short	diss;	/*Disable Alarm Sevrty*/
	unsigned char	lcnt;	/*Lock Count*/
	unsigned char	pact;	/*Record active*/
	unsigned char	putf;	/*dbPutField process*/
	unsigned char	rpro;	/*Reprocess */
	void		*asp;	/*Access Security Pvt*/
	void		*ppn;	/*addr of PUTNOTIFY*/
	void		*ppnn;	/*next record PUTNOTIFY*/
	void		*spvt;	/*Scan Private*/
	void		*rset;	/*Address of RSET*/
	struct dset	*dset;	/*DSET address*/
	void		*dpvt;	/*Device Private*/
	void		*rdes;	/*Address of dbRecordType*/
	void		*lset;	/*Lock Set*/
	unsigned short	prio;	/*Scheduling Priority*/
	unsigned char	tpro;	/*Trace Processing*/
	char bkpt;	/*Break Point*/
	unsigned char	udf;	/*Undefined*/
	TS_STAMP	time;	/*Time*/
	DBLINK		flnk;	/*Forward Process Link*/
	unsigned long	val;	/*Result*/
	char		jedf[36]; /*jedfile*/
	void *  pptr;	/*paldata*/
	DBLINK		inpa;	/*Input A*/
	DBLINK		inpb;	/*Input B*/
	DBLINK		inpc;	/*Input C*/
	DBLINK		inpd;	/*Input D*/
	DBLINK		inpe;	/*Input E*/
	DBLINK		inpf;	/*Input F*/
	DBLINK		inpg;	/*Input G*/
	DBLINK		inph;	/*Input H*/
	DBLINK		inpi;	/*Input I*/
	DBLINK		inpj;	/*Input J*/
	DBLINK		inpk;	/*Input K*/
	DBLINK		inpl;	/*Input L*/
	double		a0;	/*0 thresh of Input A*/
	double		a1;	/*1 thresh of Input A*/
	double		b0;	/*0 thresh of Input B*/
	double		b1;	/*1 thresh of Input B*/
	double		c0;	/*0 thresh of Input C*/
	double		c1;	/*1 thresh of Input C*/
	double		d0;	/*0 thresh of Input D*/
	double		d1;	/*1 thresh of Input D*/
	double		e0;	/*0 thresh of Input E*/
	double		e1;	/*1 thresh of Input E*/
	double		f0;	/*0 thresh of Input F*/
	double		f1;	/*1 thresh of Input F*/
	double		g0;	/*0 thresh of Input G*/
	double		g1;	/*1 thresh of Input G*/
	double		h0;	/*0 thresh of Input H*/
	double		h1;	/*1 thresh of Input H*/
	double		i0;	/*0 thresh of Input I*/
	double		i1;	/*1 thresh of Input I*/
	double		j0;	/*0 thresh of Input J*/
	double		j1;	/*1 thresh of Input J*/
	double		k0;	/*0 thresh of Input K*/
	double		k1;	/*1 thresh of Input K*/
	double		l0;	/*0 thresh of Input L*/
	double		l1;	/*1 thresh of Input L*/
	char		egu[16]; /*Units Name*/
	short		prec;	/*Display Precision*/
	double		a;	/*value of input A*/
	double		b;	/*value of input B*/
	double		c;	/*value of input C*/
	double		d;	/*value of input D*/
	double		e;	/*value of input E*/
	double		f;	/*value of input F*/
	double		g;	/*value of input G*/
	double		h;	/*value of input H*/
	double		i;	/*value of input I*/
	double		j;	/*value of input J*/
	double		k;	/*value of input K*/
	double		l;	/*value of input L*/
	double		la;	/*prev value of A*/
	double		lb;	/*prev value of B*/
	double		lc;	/*prev value of C*/
	double		ld;	/*prev value of D*/
	double		le;	/*prev value of E*/
	double		lf;	/*prev value of F*/
	double		lg;	/*prev value of G*/
	double		lh;	/*prev value of H*/
	double		li;	/*prev value of I*/
	double		lj;	/*prev value of J*/
	double		lk;	/*prev value of K*/
	double		ll;	/*prev value of L*/
	unsigned char	q0;	/*Value of Q0*/
	unsigned char	q1;	/*Value of Q1*/
	unsigned char	q2;	/*Value of Q2*/
	unsigned char	q3;	/*Value of Q3*/
	unsigned char	q4;	/*Value of Q4*/
	unsigned char	q5;	/*Value of Q5*/
	unsigned char	q6;	/*Value of Q6*/
	unsigned char	q7;	/*Value of Q7*/
	unsigned char	q8;	/*Value of Q8*/
	unsigned char	q9;	/*Value of Q9*/
	unsigned char	qa;	/*Value of QA*/
	unsigned char	qb;	/*Value of QB*/
	unsigned long	mlst;	/*Last Val Monitored*/
} palRecord;
#define palRecordNAME	0
#define palRecordDESC	1
#define palRecordASG	2
#define palRecordSCAN	3
#define palRecordPINI	4
#define palRecordPHAS	5
#define palRecordEVNT	6
#define palRecordTSE	7
#define palRecordTSEL	8
#define palRecordDTYP	9
#define palRecordDISV	10
#define palRecordDISA	11
#define palRecordSDIS	12
#define palRecordMLOK	13
#define palRecordMLIS	14
#define palRecordDISP	15
#define palRecordPROC	16
#define palRecordSTAT	17
#define palRecordSEVR	18
#define palRecordNSTA	19
#define palRecordNSEV	20
#define palRecordACKS	21
#define palRecordACKT	22
#define palRecordDISS	23
#define palRecordLCNT	24
#define palRecordPACT	25
#define palRecordPUTF	26
#define palRecordRPRO	27
#define palRecordASP	28
#define palRecordPPN	29
#define palRecordPPNN	30
#define palRecordSPVT	31
#define palRecordRSET	32
#define palRecordDSET	33
#define palRecordDPVT	34
#define palRecordRDES	35
#define palRecordLSET	36
#define palRecordPRIO	37
#define palRecordTPRO	38
#define palRecordBKPT	39
#define palRecordUDF	40
#define palRecordTIME	41
#define palRecordFLNK	42
#define palRecordVAL	43
#define palRecordJEDF	44
#define palRecordPPTR	45
#define palRecordINPA	46
#define palRecordINPB	47
#define palRecordINPC	48
#define palRecordINPD	49
#define palRecordINPE	50
#define palRecordINPF	51
#define palRecordINPG	52
#define palRecordINPH	53
#define palRecordINPI	54
#define palRecordINPJ	55
#define palRecordINPK	56
#define palRecordINPL	57
#define palRecordA0	58
#define palRecordA1	59
#define palRecordB0	60
#define palRecordB1	61
#define palRecordC0	62
#define palRecordC1	63
#define palRecordD0	64
#define palRecordD1	65
#define palRecordE0	66
#define palRecordE1	67
#define palRecordF0	68
#define palRecordF1	69
#define palRecordG0	70
#define palRecordG1	71
#define palRecordH0	72
#define palRecordH1	73
#define palRecordI0	74
#define palRecordI1	75
#define palRecordJ0	76
#define palRecordJ1	77
#define palRecordK0	78
#define palRecordK1	79
#define palRecordL0	80
#define palRecordL1	81
#define palRecordEGU	82
#define palRecordPREC	83
#define palRecordA	84
#define palRecordB	85
#define palRecordC	86
#define palRecordD	87
#define palRecordE	88
#define palRecordF	89
#define palRecordG	90
#define palRecordH	91
#define palRecordI	92
#define palRecordJ	93
#define palRecordK	94
#define palRecordL	95
#define palRecordLA	96
#define palRecordLB	97
#define palRecordLC	98
#define palRecordLD	99
#define palRecordLE	100
#define palRecordLF	101
#define palRecordLG	102
#define palRecordLH	103
#define palRecordLI	104
#define palRecordLJ	105
#define palRecordLK	106
#define palRecordLL	107
#define palRecordQ0	108
#define palRecordQ1	109
#define palRecordQ2	110
#define palRecordQ3	111
#define palRecordQ4	112
#define palRecordQ5	113
#define palRecordQ6	114
#define palRecordQ7	115
#define palRecordQ8	116
#define palRecordQ9	117
#define palRecordQA	118
#define palRecordQB	119
#define palRecordMLST	120
#endif /*INCpalH*/
#ifdef GEN_SIZE_OFFSET
int palRecordSizeOffset(dbRecordType *pdbRecordType)
{
    palRecord *prec = 0;
  pdbRecordType->papFldDes[0]->size=sizeof(prec->name);
  pdbRecordType->papFldDes[0]->offset=(short)((char *)&prec->name - (char *)prec);
  pdbRecordType->papFldDes[1]->size=sizeof(prec->desc);
  pdbRecordType->papFldDes[1]->offset=(short)((char *)&prec->desc - (char *)prec);
  pdbRecordType->papFldDes[2]->size=sizeof(prec->asg);
  pdbRecordType->papFldDes[2]->offset=(short)((char *)&prec->asg - (char *)prec);
  pdbRecordType->papFldDes[3]->size=sizeof(prec->scan);
  pdbRecordType->papFldDes[3]->offset=(short)((char *)&prec->scan - (char *)prec);
  pdbRecordType->papFldDes[4]->size=sizeof(prec->pini);
  pdbRecordType->papFldDes[4]->offset=(short)((char *)&prec->pini - (char *)prec);
  pdbRecordType->papFldDes[5]->size=sizeof(prec->phas);
  pdbRecordType->papFldDes[5]->offset=(short)((char *)&prec->phas - (char *)prec);
  pdbRecordType->papFldDes[6]->size=sizeof(prec->evnt);
  pdbRecordType->papFldDes[6]->offset=(short)((char *)&prec->evnt - (char *)prec);
  pdbRecordType->papFldDes[7]->size=sizeof(prec->tse);
  pdbRecordType->papFldDes[7]->offset=(short)((char *)&prec->tse - (char *)prec);
  pdbRecordType->papFldDes[8]->size=sizeof(prec->tsel);
  pdbRecordType->papFldDes[8]->offset=(short)((char *)&prec->tsel - (char *)prec);
  pdbRecordType->papFldDes[9]->size=sizeof(prec->dtyp);
  pdbRecordType->papFldDes[9]->offset=(short)((char *)&prec->dtyp - (char *)prec);
  pdbRecordType->papFldDes[10]->size=sizeof(prec->disv);
  pdbRecordType->papFldDes[10]->offset=(short)((char *)&prec->disv - (char *)prec);
  pdbRecordType->papFldDes[11]->size=sizeof(prec->disa);
  pdbRecordType->papFldDes[11]->offset=(short)((char *)&prec->disa - (char *)prec);
  pdbRecordType->papFldDes[12]->size=sizeof(prec->sdis);
  pdbRecordType->papFldDes[12]->offset=(short)((char *)&prec->sdis - (char *)prec);
  pdbRecordType->papFldDes[13]->size=sizeof(prec->mlok);
  pdbRecordType->papFldDes[13]->offset=(short)((char *)&prec->mlok - (char *)prec);
  pdbRecordType->papFldDes[14]->size=sizeof(prec->mlis);
  pdbRecordType->papFldDes[14]->offset=(short)((char *)&prec->mlis - (char *)prec);
  pdbRecordType->papFldDes[15]->size=sizeof(prec->disp);
  pdbRecordType->papFldDes[15]->offset=(short)((char *)&prec->disp - (char *)prec);
  pdbRecordType->papFldDes[16]->size=sizeof(prec->proc);
  pdbRecordType->papFldDes[16]->offset=(short)((char *)&prec->proc - (char *)prec);
  pdbRecordType->papFldDes[17]->size=sizeof(prec->stat);
  pdbRecordType->papFldDes[17]->offset=(short)((char *)&prec->stat - (char *)prec);
  pdbRecordType->papFldDes[18]->size=sizeof(prec->sevr);
  pdbRecordType->papFldDes[18]->offset=(short)((char *)&prec->sevr - (char *)prec);
  pdbRecordType->papFldDes[19]->size=sizeof(prec->nsta);
  pdbRecordType->papFldDes[19]->offset=(short)((char *)&prec->nsta - (char *)prec);
  pdbRecordType->papFldDes[20]->size=sizeof(prec->nsev);
  pdbRecordType->papFldDes[20]->offset=(short)((char *)&prec->nsev - (char *)prec);
  pdbRecordType->papFldDes[21]->size=sizeof(prec->acks);
  pdbRecordType->papFldDes[21]->offset=(short)((char *)&prec->acks - (char *)prec);
  pdbRecordType->papFldDes[22]->size=sizeof(prec->ackt);
  pdbRecordType->papFldDes[22]->offset=(short)((char *)&prec->ackt - (char *)prec);
  pdbRecordType->papFldDes[23]->size=sizeof(prec->diss);
  pdbRecordType->papFldDes[23]->offset=(short)((char *)&prec->diss - (char *)prec);
  pdbRecordType->papFldDes[24]->size=sizeof(prec->lcnt);
  pdbRecordType->papFldDes[24]->offset=(short)((char *)&prec->lcnt - (char *)prec);
  pdbRecordType->papFldDes[25]->size=sizeof(prec->pact);
  pdbRecordType->papFldDes[25]->offset=(short)((char *)&prec->pact - (char *)prec);
  pdbRecordType->papFldDes[26]->size=sizeof(prec->putf);
  pdbRecordType->papFldDes[26]->offset=(short)((char *)&prec->putf - (char *)prec);
  pdbRecordType->papFldDes[27]->size=sizeof(prec->rpro);
  pdbRecordType->papFldDes[27]->offset=(short)((char *)&prec->rpro - (char *)prec);
  pdbRecordType->papFldDes[28]->size=sizeof(prec->asp);
  pdbRecordType->papFldDes[28]->offset=(short)((char *)&prec->asp - (char *)prec);
  pdbRecordType->papFldDes[29]->size=sizeof(prec->ppn);
  pdbRecordType->papFldDes[29]->offset=(short)((char *)&prec->ppn - (char *)prec);
  pdbRecordType->papFldDes[30]->size=sizeof(prec->ppnn);
  pdbRecordType->papFldDes[30]->offset=(short)((char *)&prec->ppnn - (char *)prec);
  pdbRecordType->papFldDes[31]->size=sizeof(prec->spvt);
  pdbRecordType->papFldDes[31]->offset=(short)((char *)&prec->spvt - (char *)prec);
  pdbRecordType->papFldDes[32]->size=sizeof(prec->rset);
  pdbRecordType->papFldDes[32]->offset=(short)((char *)&prec->rset - (char *)prec);
  pdbRecordType->papFldDes[33]->size=sizeof(prec->dset);
  pdbRecordType->papFldDes[33]->offset=(short)((char *)&prec->dset - (char *)prec);
  pdbRecordType->papFldDes[34]->size=sizeof(prec->dpvt);
  pdbRecordType->papFldDes[34]->offset=(short)((char *)&prec->dpvt - (char *)prec);
  pdbRecordType->papFldDes[35]->size=sizeof(prec->rdes);
  pdbRecordType->papFldDes[35]->offset=(short)((char *)&prec->rdes - (char *)prec);
  pdbRecordType->papFldDes[36]->size=sizeof(prec->lset);
  pdbRecordType->papFldDes[36]->offset=(short)((char *)&prec->lset - (char *)prec);
  pdbRecordType->papFldDes[37]->size=sizeof(prec->prio);
  pdbRecordType->papFldDes[37]->offset=(short)((char *)&prec->prio - (char *)prec);
  pdbRecordType->papFldDes[38]->size=sizeof(prec->tpro);
  pdbRecordType->papFldDes[38]->offset=(short)((char *)&prec->tpro - (char *)prec);
  pdbRecordType->papFldDes[39]->size=sizeof(prec->bkpt);
  pdbRecordType->papFldDes[39]->offset=(short)((char *)&prec->bkpt - (char *)prec);
  pdbRecordType->papFldDes[40]->size=sizeof(prec->udf);
  pdbRecordType->papFldDes[40]->offset=(short)((char *)&prec->udf - (char *)prec);
  pdbRecordType->papFldDes[41]->size=sizeof(prec->time);
  pdbRecordType->papFldDes[41]->offset=(short)((char *)&prec->time - (char *)prec);
  pdbRecordType->papFldDes[42]->size=sizeof(prec->flnk);
  pdbRecordType->papFldDes[42]->offset=(short)((char *)&prec->flnk - (char *)prec);
  pdbRecordType->papFldDes[43]->size=sizeof(prec->val);
  pdbRecordType->papFldDes[43]->offset=(short)((char *)&prec->val - (char *)prec);
  pdbRecordType->papFldDes[44]->size=sizeof(prec->jedf);
  pdbRecordType->papFldDes[44]->offset=(short)((char *)&prec->jedf - (char *)prec);
  pdbRecordType->papFldDes[45]->size=sizeof(prec->pptr);
  pdbRecordType->papFldDes[45]->offset=(short)((char *)&prec->pptr - (char *)prec);
  pdbRecordType->papFldDes[46]->size=sizeof(prec->inpa);
  pdbRecordType->papFldDes[46]->offset=(short)((char *)&prec->inpa - (char *)prec);
  pdbRecordType->papFldDes[47]->size=sizeof(prec->inpb);
  pdbRecordType->papFldDes[47]->offset=(short)((char *)&prec->inpb - (char *)prec);
  pdbRecordType->papFldDes[48]->size=sizeof(prec->inpc);
  pdbRecordType->papFldDes[48]->offset=(short)((char *)&prec->inpc - (char *)prec);
  pdbRecordType->papFldDes[49]->size=sizeof(prec->inpd);
  pdbRecordType->papFldDes[49]->offset=(short)((char *)&prec->inpd - (char *)prec);
  pdbRecordType->papFldDes[50]->size=sizeof(prec->inpe);
  pdbRecordType->papFldDes[50]->offset=(short)((char *)&prec->inpe - (char *)prec);
  pdbRecordType->papFldDes[51]->size=sizeof(prec->inpf);
  pdbRecordType->papFldDes[51]->offset=(short)((char *)&prec->inpf - (char *)prec);
  pdbRecordType->papFldDes[52]->size=sizeof(prec->inpg);
  pdbRecordType->papFldDes[52]->offset=(short)((char *)&prec->inpg - (char *)prec);
  pdbRecordType->papFldDes[53]->size=sizeof(prec->inph);
  pdbRecordType->papFldDes[53]->offset=(short)((char *)&prec->inph - (char *)prec);
  pdbRecordType->papFldDes[54]->size=sizeof(prec->inpi);
  pdbRecordType->papFldDes[54]->offset=(short)((char *)&prec->inpi - (char *)prec);
  pdbRecordType->papFldDes[55]->size=sizeof(prec->inpj);
  pdbRecordType->papFldDes[55]->offset=(short)((char *)&prec->inpj - (char *)prec);
  pdbRecordType->papFldDes[56]->size=sizeof(prec->inpk);
  pdbRecordType->papFldDes[56]->offset=(short)((char *)&prec->inpk - (char *)prec);
  pdbRecordType->papFldDes[57]->size=sizeof(prec->inpl);
  pdbRecordType->papFldDes[57]->offset=(short)((char *)&prec->inpl - (char *)prec);
  pdbRecordType->papFldDes[58]->size=sizeof(prec->a0);
  pdbRecordType->papFldDes[58]->offset=(short)((char *)&prec->a0 - (char *)prec);
  pdbRecordType->papFldDes[59]->size=sizeof(prec->a1);
  pdbRecordType->papFldDes[59]->offset=(short)((char *)&prec->a1 - (char *)prec);
  pdbRecordType->papFldDes[60]->size=sizeof(prec->b0);
  pdbRecordType->papFldDes[60]->offset=(short)((char *)&prec->b0 - (char *)prec);
  pdbRecordType->papFldDes[61]->size=sizeof(prec->b1);
  pdbRecordType->papFldDes[61]->offset=(short)((char *)&prec->b1 - (char *)prec);
  pdbRecordType->papFldDes[62]->size=sizeof(prec->c0);
  pdbRecordType->papFldDes[62]->offset=(short)((char *)&prec->c0 - (char *)prec);
  pdbRecordType->papFldDes[63]->size=sizeof(prec->c1);
  pdbRecordType->papFldDes[63]->offset=(short)((char *)&prec->c1 - (char *)prec);
  pdbRecordType->papFldDes[64]->size=sizeof(prec->d0);
  pdbRecordType->papFldDes[64]->offset=(short)((char *)&prec->d0 - (char *)prec);
  pdbRecordType->papFldDes[65]->size=sizeof(prec->d1);
  pdbRecordType->papFldDes[65]->offset=(short)((char *)&prec->d1 - (char *)prec);
  pdbRecordType->papFldDes[66]->size=sizeof(prec->e0);
  pdbRecordType->papFldDes[66]->offset=(short)((char *)&prec->e0 - (char *)prec);
  pdbRecordType->papFldDes[67]->size=sizeof(prec->e1);
  pdbRecordType->papFldDes[67]->offset=(short)((char *)&prec->e1 - (char *)prec);
  pdbRecordType->papFldDes[68]->size=sizeof(prec->f0);
  pdbRecordType->papFldDes[68]->offset=(short)((char *)&prec->f0 - (char *)prec);
  pdbRecordType->papFldDes[69]->size=sizeof(prec->f1);
  pdbRecordType->papFldDes[69]->offset=(short)((char *)&prec->f1 - (char *)prec);
  pdbRecordType->papFldDes[70]->size=sizeof(prec->g0);
  pdbRecordType->papFldDes[70]->offset=(short)((char *)&prec->g0 - (char *)prec);
  pdbRecordType->papFldDes[71]->size=sizeof(prec->g1);
  pdbRecordType->papFldDes[71]->offset=(short)((char *)&prec->g1 - (char *)prec);
  pdbRecordType->papFldDes[72]->size=sizeof(prec->h0);
  pdbRecordType->papFldDes[72]->offset=(short)((char *)&prec->h0 - (char *)prec);
  pdbRecordType->papFldDes[73]->size=sizeof(prec->h1);
  pdbRecordType->papFldDes[73]->offset=(short)((char *)&prec->h1 - (char *)prec);
  pdbRecordType->papFldDes[74]->size=sizeof(prec->i0);
  pdbRecordType->papFldDes[74]->offset=(short)((char *)&prec->i0 - (char *)prec);
  pdbRecordType->papFldDes[75]->size=sizeof(prec->i1);
  pdbRecordType->papFldDes[75]->offset=(short)((char *)&prec->i1 - (char *)prec);
  pdbRecordType->papFldDes[76]->size=sizeof(prec->j0);
  pdbRecordType->papFldDes[76]->offset=(short)((char *)&prec->j0 - (char *)prec);
  pdbRecordType->papFldDes[77]->size=sizeof(prec->j1);
  pdbRecordType->papFldDes[77]->offset=(short)((char *)&prec->j1 - (char *)prec);
  pdbRecordType->papFldDes[78]->size=sizeof(prec->k0);
  pdbRecordType->papFldDes[78]->offset=(short)((char *)&prec->k0 - (char *)prec);
  pdbRecordType->papFldDes[79]->size=sizeof(prec->k1);
  pdbRecordType->papFldDes[79]->offset=(short)((char *)&prec->k1 - (char *)prec);
  pdbRecordType->papFldDes[80]->size=sizeof(prec->l0);
  pdbRecordType->papFldDes[80]->offset=(short)((char *)&prec->l0 - (char *)prec);
  pdbRecordType->papFldDes[81]->size=sizeof(prec->l1);
  pdbRecordType->papFldDes[81]->offset=(short)((char *)&prec->l1 - (char *)prec);
  pdbRecordType->papFldDes[82]->size=sizeof(prec->egu);
  pdbRecordType->papFldDes[82]->offset=(short)((char *)&prec->egu - (char *)prec);
  pdbRecordType->papFldDes[83]->size=sizeof(prec->prec);
  pdbRecordType->papFldDes[83]->offset=(short)((char *)&prec->prec - (char *)prec);
  pdbRecordType->papFldDes[84]->size=sizeof(prec->a);
  pdbRecordType->papFldDes[84]->offset=(short)((char *)&prec->a - (char *)prec);
  pdbRecordType->papFldDes[85]->size=sizeof(prec->b);
  pdbRecordType->papFldDes[85]->offset=(short)((char *)&prec->b - (char *)prec);
  pdbRecordType->papFldDes[86]->size=sizeof(prec->c);
  pdbRecordType->papFldDes[86]->offset=(short)((char *)&prec->c - (char *)prec);
  pdbRecordType->papFldDes[87]->size=sizeof(prec->d);
  pdbRecordType->papFldDes[87]->offset=(short)((char *)&prec->d - (char *)prec);
  pdbRecordType->papFldDes[88]->size=sizeof(prec->e);
  pdbRecordType->papFldDes[88]->offset=(short)((char *)&prec->e - (char *)prec);
  pdbRecordType->papFldDes[89]->size=sizeof(prec->f);
  pdbRecordType->papFldDes[89]->offset=(short)((char *)&prec->f - (char *)prec);
  pdbRecordType->papFldDes[90]->size=sizeof(prec->g);
  pdbRecordType->papFldDes[90]->offset=(short)((char *)&prec->g - (char *)prec);
  pdbRecordType->papFldDes[91]->size=sizeof(prec->h);
  pdbRecordType->papFldDes[91]->offset=(short)((char *)&prec->h - (char *)prec);
  pdbRecordType->papFldDes[92]->size=sizeof(prec->i);
  pdbRecordType->papFldDes[92]->offset=(short)((char *)&prec->i - (char *)prec);
  pdbRecordType->papFldDes[93]->size=sizeof(prec->j);
  pdbRecordType->papFldDes[93]->offset=(short)((char *)&prec->j - (char *)prec);
  pdbRecordType->papFldDes[94]->size=sizeof(prec->k);
  pdbRecordType->papFldDes[94]->offset=(short)((char *)&prec->k - (char *)prec);
  pdbRecordType->papFldDes[95]->size=sizeof(prec->l);
  pdbRecordType->papFldDes[95]->offset=(short)((char *)&prec->l - (char *)prec);
  pdbRecordType->papFldDes[96]->size=sizeof(prec->la);
  pdbRecordType->papFldDes[96]->offset=(short)((char *)&prec->la - (char *)prec);
  pdbRecordType->papFldDes[97]->size=sizeof(prec->lb);
  pdbRecordType->papFldDes[97]->offset=(short)((char *)&prec->lb - (char *)prec);
  pdbRecordType->papFldDes[98]->size=sizeof(prec->lc);
  pdbRecordType->papFldDes[98]->offset=(short)((char *)&prec->lc - (char *)prec);
  pdbRecordType->papFldDes[99]->size=sizeof(prec->ld);
  pdbRecordType->papFldDes[99]->offset=(short)((char *)&prec->ld - (char *)prec);
  pdbRecordType->papFldDes[100]->size=sizeof(prec->le);
  pdbRecordType->papFldDes[100]->offset=(short)((char *)&prec->le - (char *)prec);
  pdbRecordType->papFldDes[101]->size=sizeof(prec->lf);
  pdbRecordType->papFldDes[101]->offset=(short)((char *)&prec->lf - (char *)prec);
  pdbRecordType->papFldDes[102]->size=sizeof(prec->lg);
  pdbRecordType->papFldDes[102]->offset=(short)((char *)&prec->lg - (char *)prec);
  pdbRecordType->papFldDes[103]->size=sizeof(prec->lh);
  pdbRecordType->papFldDes[103]->offset=(short)((char *)&prec->lh - (char *)prec);
  pdbRecordType->papFldDes[104]->size=sizeof(prec->li);
  pdbRecordType->papFldDes[104]->offset=(short)((char *)&prec->li - (char *)prec);
  pdbRecordType->papFldDes[105]->size=sizeof(prec->lj);
  pdbRecordType->papFldDes[105]->offset=(short)((char *)&prec->lj - (char *)prec);
  pdbRecordType->papFldDes[106]->size=sizeof(prec->lk);
  pdbRecordType->papFldDes[106]->offset=(short)((char *)&prec->lk - (char *)prec);
  pdbRecordType->papFldDes[107]->size=sizeof(prec->ll);
  pdbRecordType->papFldDes[107]->offset=(short)((char *)&prec->ll - (char *)prec);
  pdbRecordType->papFldDes[108]->size=sizeof(prec->q0);
  pdbRecordType->papFldDes[108]->offset=(short)((char *)&prec->q0 - (char *)prec);
  pdbRecordType->papFldDes[109]->size=sizeof(prec->q1);
  pdbRecordType->papFldDes[109]->offset=(short)((char *)&prec->q1 - (char *)prec);
  pdbRecordType->papFldDes[110]->size=sizeof(prec->q2);
  pdbRecordType->papFldDes[110]->offset=(short)((char *)&prec->q2 - (char *)prec);
  pdbRecordType->papFldDes[111]->size=sizeof(prec->q3);
  pdbRecordType->papFldDes[111]->offset=(short)((char *)&prec->q3 - (char *)prec);
  pdbRecordType->papFldDes[112]->size=sizeof(prec->q4);
  pdbRecordType->papFldDes[112]->offset=(short)((char *)&prec->q4 - (char *)prec);
  pdbRecordType->papFldDes[113]->size=sizeof(prec->q5);
  pdbRecordType->papFldDes[113]->offset=(short)((char *)&prec->q5 - (char *)prec);
  pdbRecordType->papFldDes[114]->size=sizeof(prec->q6);
  pdbRecordType->papFldDes[114]->offset=(short)((char *)&prec->q6 - (char *)prec);
  pdbRecordType->papFldDes[115]->size=sizeof(prec->q7);
  pdbRecordType->papFldDes[115]->offset=(short)((char *)&prec->q7 - (char *)prec);
  pdbRecordType->papFldDes[116]->size=sizeof(prec->q8);
  pdbRecordType->papFldDes[116]->offset=(short)((char *)&prec->q8 - (char *)prec);
  pdbRecordType->papFldDes[117]->size=sizeof(prec->q9);
  pdbRecordType->papFldDes[117]->offset=(short)((char *)&prec->q9 - (char *)prec);
  pdbRecordType->papFldDes[118]->size=sizeof(prec->qa);
  pdbRecordType->papFldDes[118]->offset=(short)((char *)&prec->qa - (char *)prec);
  pdbRecordType->papFldDes[119]->size=sizeof(prec->qb);
  pdbRecordType->papFldDes[119]->offset=(short)((char *)&prec->qb - (char *)prec);
  pdbRecordType->papFldDes[120]->size=sizeof(prec->mlst);
  pdbRecordType->papFldDes[120]->offset=(short)((char *)&prec->mlst - (char *)prec);
    pdbRecordType->rec_size = sizeof(*prec);
    return(0);
}
#endif /*GEN_SIZE_OFFSET*/
